Scriptname DSerDummyQuestScript  extends quest

;======= PROPERTIES ===========
GlobalVariable Property DSerScriptRunning auto
GlobalVariable Property GripHasBeenChanged auto
GlobalVariable Property GlobalHotkey auto
GlobalVariable Property GlobalHotkey2 auto
GlobalVariable Property SecondaryHotkeyEnabled auto
GlobalVariable Property ExtraWait auto
GlobalVariable Property WeaponDamage auto
GlobalVariable Property WeaponSpeed auto
GlobalVariable Property DamageChange auto
GlobalVariable Property SpeedChange auto
GlobalVariable Property SkillsMatch auto
GlobalVariable Property WasMaceGlobal auto
GlobalVariable Property WasDaggerGlobal auto
GlobalVariable Property WasWarAxeGlobal auto
GlobalVariable Property BeenAutoChanged auto

;======= VARIABLES ===========
weapon EquippedWeaponRight
weapon EquippedWeaponLeft

form EquippedShield

spell EquippedSpell

int IstheMenuOpen = 0
int Modifier = 0
int WeaponTypeRight
int WeaponTypeLeft
int SwordType =1
int DaggerType = 2
int WarAxeType = 3
int MaceType = 4
int GreatswordType = 5
int BattleaxeWarhammerType = 6
int WasMace = 0
int WasDagger = 0
int WasWarAxe = 0
int HadSomethingEquippedWeapon
int HadSomethingEquippedShield
int HadSomethingEquippedSpell

float PlayerIsRunning = 0.0
float ExtraWaitA

equipslot WeaponEquipTypeRight
equipslot WeaponEquipTypeLeft
equipslot OneHandedSlot
equipslot EitherHandedSlot
equipslot TwoHandedSlot

Actor PlayerRef
;==========================

Event OnInit()
	PlayerRef = Game.GetPlayer()											;create a player reference
	OneHandedSlot = Game.GetForm(0x00013f42) As EquipSlot				;weapon slot for a one handed weapon
	EitherHandedSlot = Game.GetForm(0x00013f44) As EquipSlot				;weapon slot for a either handed weapon
	TwoHandedSlot = Game.GetForm(0x00013F45) As EquipSlot				;weapon slot for a two handed weapon
	debug.trace("[Unlocked Grip] Grip Setup Complete.")
EndEvent

Event OnKeyDown(int KeyCode)	
	If(KeyCode == GlobalHotkey.GetValue())
		Modifier = 1
		If(SecondaryHotkeyEnabled.GetValue() == 1)
			return
		EndIf
	EndIf

	If(DSerScriptRunning.GetValue())||(Utility.IsInMenuMode() == true)			;Don't run the script if it's already running or if you're in a menu
		return
	EndIf

	If(SecondaryHotkeyEnabled.GetValueInt() == 1)&&(Modifier == 0)&&(KeyCode == GlobalHotkey2.GetValueInt())
		return
	EndIf

	DSerScriptRunning.SetValue(1)

	EquippedWeaponRight = PlayerRef.GetEquippedWeapon()					;get right hand weapon id data
	EquippedWeaponLeft = PlayerRef.GetEquippedWeapon(true)					;get left hand weapon id data

	;\\\\\\\\\\ CHECK RIGHT HAND \\\\\\\\\\\

	If(EquippedWeaponRight)

		;======= SET UP THE WEAPONS' CURRENT STATS (TYPE, EQUIP TYPE) =======================================
		WeaponTypeRight = EquippedWeaponRight.GetWeaponType()				;returns the weapon type
		WeaponEquipTypeRight = EquippedWeaponRight.GetEquipType()				;returns the equip type, right hand or two-handed
		ExtraWaitA = ExtraWait.GetValue()

		If(BeenAutoChanged.GetValueInt() == 1)
			WasMace = WasMaceGlobal.GetValueInt()
			WasDagger = WasDaggerGlobal.GetValueInt()
			WasWarAxe = WasWarAxeGlobal.GetValueInt()
			BeenAutoChanged.SetValue(0)
		EndIf
		;====================================================================================

		;++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;======================= SWORD =========================
		;++++++++++++++++++++++++++++++++++++++++++++++++++++++

		;======= IF RIGHT HAND IS SWORD + ONE-HANDED ==================================================
		If((WeaponEquipTypeRight == (OneHandedSlot||EitherHandedSlot))&&(WeaponTypeRight == SwordType)&&(GripHasBeenChanged.GetValue() == 0))
				debug.trace("[Unlocked Grip] Sword is changing to two-handed mode")

				;---------- REMOVE ANYTHING FROM THE PLAYERS LEFT HAND -----------------------------------------------------------------------------------
				If(EquippedWeaponLeft)													;Check for anything in the left hand and unequip it if true
					PlayerRef.UnequipItem(EquippedWeaponLeft,false,true)				;unequip the left hand weapon
					HadSomethingEquippedWeapon = 1
				ElseIf(PlayerRef.GetEquippedShield())
					EquippedShield = PlayerRef.GetEquippedShield()						;record the shields' id
					PlayerRef.UnequipItem(PlayerRef.GetEquippedShield(),false,true)		;unequips any shield
					HadSomethingEquippedShield = 1
				ElseIf(PlayerRef.GetEquippedSpell(0))
					EquippedSpell = PlayerRef.GetEquippedSpell(0)						;record the spells' id
					PlayerRef.UnequipSpell(PlayerRef.GetEquippedSpell(0),0)				;unequips the left hand spell
					HadSomethingEquippedSpell = 1
				EndIf
				;--------------------------------------------------------------------------------------------------------------------------------------------------------------
	
				;---------- SWITCH THE WEAPON TO TWO-HANDED MODE -----------------------------------------------------------------------------------------
				PlayerRef.UnequipItem(EquippedWeaponRight,false,true)			;unequip the right hand weapon
				If(SkillsMatch.GetValue())
					EquippedWeaponRight.SetSkill("TwoHanded")						;changes the skill
				EndIf
				EquippedWeaponRight.SetEquipType(TwoHandedSlot)				;changes the equip type in the menu into LR
				EquippedWeaponRight.SetWeaponType(GreatswordType)			;changes the weapon type to two-handed, affects animations
				Utility.Wait(0.1+ExtraWaitA)
				PlayerRef.EquipItem(EquippedWeaponRight,false,true)				;re-equip the right hand weapon
				Utility.Wait(0.1+ExtraWaitA)
				EquippedWeaponRight.SetWeaponType(SwordType)					;changes the weapon type to one-handed, affects animations
				PlayerRef.DrawWeapon()											;draw the right hand weapon, required
				utility.wait(1.5)														;necessary wait time for the draw animation
				EquippedWeaponRight.SetWeaponType(GreatswordType)			;fix the invisible left hand weapon bug, allows blocking

				EquippedWeaponRight.SetBaseDamage((WeaponDamage.GetValue()*(1.0+DamageChange.GetValue())) as int)
				EquippedWeaponRight.SetSpeed(WeaponSpeed.GetValue()*(1.0+SpeedChange.GetValue()))
				;---------------------------------------------------------------------------------------------------------------------------------------------------------------
				
				GripHasBeenChanged.SetValue(1)
				WasMace = 0
				WasDagger = 0
				WasWarAxe = 0
		;====================================================================================

		;======= IF RIGHT HAND IS SWORD + TWO HANDED ==================================================
		ElseIf((WeaponEquipTypeRight == TwoHandedSlot)&&(WeaponTypeRight == GreatswordType)&&(WasMace == 0)&&(WasDagger == 0)&&(WasWarAxe == 0)&&(GripHasBeenChanged.GetValue() ==1))
				debug.trace("[Unlocked Grip] Sword is changing to one-handed mode")

				;---------- SWITCH THE WEAPON TO ONE-HANDED MODE -----------------------------------------------------------------------------------------
				PlayerRef.UnequipItem(EquippedWeaponRight,false,true)			;unequip the right hand weapon
				If(SkillsMatch.GetValue())
					EquippedWeaponRight.SetSkill("OneHanded")
				EndIf
				EquippedWeaponRight.SetWeaponType(SwordType)					;change the weapon type to one-handed, affects animations
				;utility.wait(0.1+ExtraWaitA)

					;---------- REPLACE THE UNEQUIPPED LEFT HAND OBJECT -----------------------------------------------------------------------------------
					If(HadSomethingEquippedWeapon)
						PlayerRef.EquipItemEx(EquippedWeaponLeft,2,false,true)			;re-equip the unequipped left hand weapon
						HadSomethingEquippedWeapon = 0
					ElseIf(HadSomethingEquippedShield)
						PlayerRef.EquipItem(EquippedShield,false,true)						;re-equip the unequipped shield
						HadSomethingEquippedShield = 0
					ElseIf(HadSomethingEquippedSpell)
						PlayerRef.EquipSpell(EquippedSpell, 0)								;re-equip the unequipped left hand spell
						HadSomethingEquippedSpell = 0
					EndIf
					;--------------------------------------------------------------------------------------------------------------------------------------------------------

				EquippedWeaponRight.SetEquipType(OneHandedSlot)				;change the equip type in the menu into R
				Utility.Wait(0.1+ExtraWaitA)
				PlayerRef.EquipItem(EquippedWeaponRight,false,true)				;re-equip the right hand weapon
				utility.wait(1+ExtraWaitA)											;wait for the draw animation to end before allowing another change in grip
	
				EquippedWeaponRight.SetBaseDamage((WeaponDamage.GetValue()) as int)
				EquippedWeaponRight.SetSpeed(WeaponSpeed.GetValue())
				;-------------------------------------------------------------------------------------------------------------------------------------------------------------
				
				GripHasBeenChanged.SetValue(0)
		;====================================================================================

		;++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;======================= DAGGER =========================
		;++++++++++++++++++++++++++++++++++++++++++++++++++++++

		;======= IF RIGHT HAND IS DAGGER + ONE-HANDED ====================
		ElseIf((WeaponEquipTypeRight == (OneHandedSlot||EitherHandedSlot))&&(WeaponTypeRight == DaggerType)&&(GripHasBeenChanged.GetValue() == 0))
				debug.trace("[Unlocked Grip] Dagger is changing to two-handed mode")

				;---------- REMOVE ANYTHING FROM THE PLAYERS LEFT HAND -----------------------------------------------------------------------------------
				If(EquippedWeaponLeft)
					PlayerRef.UnequipItem(EquippedWeaponLeft,false,true)
					HadSomethingEquippedWeapon = 1
				ElseIf(PlayerRef.GetEquippedShield())
					EquippedShield = PlayerRef.GetEquippedShield()
					PlayerRef.UnequipItem(PlayerRef.GetEquippedShield(),false,true)	
					HadSomethingEquippedShield = 1
				ElseIf(PlayerRef.GetEquippedSpell(0))
					EquippedSpell = PlayerRef.GetEquippedSpell(0)
					PlayerRef.UnequipSpell(PlayerRef.GetEquippedSpell(0),0)
					HadSomethingEquippedSpell = 1
				EndIf
				;--------------------------------------------------------------------------------------------------------------------------------------------------------------
	
				;---------- SWITCH THE WEAPON TO TWO-HANDED MODE -----------------------------------------------------------------------------------------
				PlayerRef.UnequipItem(EquippedWeaponRight,false,true)
				If(SkillsMatch.GetValue())
					EquippedWeaponRight.SetSkill("TwoHanded")
				EndIf
				EquippedWeaponRight.SetEquipType(TwoHandedSlot)
				EquippedWeaponRight.SetWeaponType(GreatswordType)
				utility.wait(0.1+ExtraWaitA)
				PlayerRef.EquipItem(EquippedWeaponRight,false,true)
				Utility.Wait(0.1+ExtraWaitA)
				EquippedWeaponRight.SetWeaponType(DaggerType)
				PlayerRef.DrawWeapon()
				utility.wait(1.5)
				EquippedWeaponRight.SetWeaponType(GreatswordType)
	
				EquippedWeaponRight.SetBaseDamage((WeaponDamage.GetValue()*(1.0+DamageChange.GetValue())) as int)
				EquippedWeaponRight.SetSpeed(WeaponSpeed.GetValue()*(1.0+SpeedChange.GetValue()))
				;---------------------------------------------------------------------------------------------------------------------------------------------------------------
				
				GripHasBeenChanged.SetValue(1)
				WasMace = 0
				WasDagger = 1
				WasWarAxe = 0
		;====================================================

		;======= IF RIGHT HAND IS DAGGER + TWO HANDED ==================
		ElseIf((WeaponEquipTypeRight == TwoHandedSlot)&&(WeaponTypeRight == GreatswordType)&&(WasMace == 0)&&(WasWarAxe == 0)&&(GripHasBeenChanged.GetValue() ==1))
				debug.trace("[Unlocked Grip] Dagger is changing to one-handed mode")

				;---------- SWITCH THE WEAPON TO ONE-HANDED MODE -----------------------------------------------------------------------------------------
				PlayerRef.UnequipItem(EquippedWeaponRight,false,true)
				If(SkillsMatch.GetValue())
					EquippedWeaponRight.SetSkill("OneHanded")
				EndIf
				EquippedWeaponRight.SetWeaponType(DaggerType)
				;utility.wait(0.1+ExtraWaitA)

					;---------- REPLACE THE UNEQUIPPED LEFT HAND OBJECT -----------------------------------------------------------------------------------
					If(HadSomethingEquippedWeapon)
						PlayerRef.EquipItemEx(EquippedWeaponLeft,2,false,true)
						HadSomethingEquippedWeapon = 0
					ElseIf(HadSomethingEquippedShield)
						PlayerRef.EquipItem(EquippedShield,false,true)
						HadSomethingEquippedShield = 0
					ElseIf(HadSomethingEquippedSpell)
						PlayerRef.EquipSpell(EquippedSpell, 0)
						HadSomethingEquippedSpell = 0
					EndIf
					;--------------------------------------------------------------------------------------------------------------------------------------------------------

				EquippedWeaponRight.SetEquipType(OneHandedSlot)
				Utility.Wait(0.1+ExtraWaitA)
				PlayerRef.EquipItem(EquippedWeaponRight,false,true)
				utility.wait(1+ExtraWaitA)
	
				EquippedWeaponRight.SetBaseDamage((WeaponDamage.GetValue()) as int)
				EquippedWeaponRight.SetSpeed(WeaponSpeed.GetValue())
				;-------------------------------------------------------------------------------------------------------------------------------------------------------------
				
				GripHasBeenChanged.SetValue(0)
		;=========================================================

		;++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;=========================WAR AXE=========================
		;++++++++++++++++++++++++++++++++++++++++++++++++++++++++

		;======= IF RIGHT HAND IS WAR AXE + ONE-HANDED =======================
		ElseIf((WeaponEquipTypeRight == (OneHandedSlot||EitherHandedSlot))&&(WeaponTypeRight == WarAxeType)&&(GripHasBeenChanged.GetValue() == 0))
				debug.trace("[Unlocked Grip] War axe is changing to two-handed mode")

				;---------- REMOVE ANYTHING FROM THE PLAYERS LEFT HAND ------------------------------------------------------------------------------------
				If(EquippedWeaponLeft)	
					PlayerRef.UnequipItem(EquippedWeaponLeft,false,true)
					HadSomethingEquippedWeapon = 1
				ElseIf(PlayerRef.GetEquippedShield())
					EquippedShield = PlayerRef.GetEquippedShield()
					PlayerRef.UnequipItem(PlayerRef.GetEquippedShield(),false,true)	
					HadSomethingEquippedShield = 1
				ElseIf(PlayerRef.GetEquippedSpell(0))
					EquippedSpell = PlayerRef.GetEquippedSpell(0)
					PlayerRef.UnequipSpell(PlayerRef.GetEquippedSpell(0),0)
					HadSomethingEquippedSpell = 1
				EndIf
				;---------------------------------------------------------------------------------------------------------------------------------------------------------------
	
				;---------- SWITCH THE WEAPON TO TWO-HANDED MODE ------------------------------------------------------------------------------------------
				PlayerRef.UnequipItem(EquippedWeaponRight,false,true)
				If(SkillsMatch.GetValue())
					EquippedWeaponRight.SetSkill("TwoHanded")
				EndIf
				EquippedWeaponRight.SetEquipType(TwoHandedSlot)
				EquippedWeaponRight.SetWeaponType(GreatswordType)
				utility.wait(0.1+ExtraWaitA)
				PlayerRef.EquipItem(EquippedWeaponRight,false,true)
				Utility.Wait(0.1+ExtraWaitA)
				EquippedWeaponRight.SetWeaponType(WarAxeType)
				PlayerRef.DrawWeapon()
				utility.wait(1.5)
				EquippedWeaponRight.SetWeaponType(GreatswordType)

				EquippedWeaponRight.SetBaseDamage((WeaponDamage.GetValue()*(1.0+DamageChange.GetValue())) as int)
				EquippedWeaponRight.SetSpeed(WeaponSpeed.GetValue()*(1.0+SpeedChange.GetValue()))
				;---------------------------------------------------------------------------------------------------------------------------------------------------------------
				
				GripHasBeenChanged.SetValue(1)
				WasMace = 0
				WasDagger = 0
				WasWarAxe = 1
		;======================================================

		;======= IF RIGHT HAND IS WAR AXE + TWO HANDED ===================
		ElseIf((WeaponEquipTypeRight == TwoHandedSlot)&&(WeaponTypeRight == GreatswordType)&&(WasMace == 0)&&(GripHasBeenChanged.GetValue() == 1))
				debug.trace("[Unlocked Grip] War axe is changing to one-handed mode")

				;---------- SWITCH THE WEAPON TO ONE-HANDED MODE -------------------------------------------------------------------------------------------
				PlayerRef.UnequipItem(EquippedWeaponRight,false,true)
				If(SkillsMatch.GetValue())
					EquippedWeaponRight.SetSkill("OneHanded")
				EndIf
				EquippedWeaponRight.SetWeaponType(WarAxeType)

					;---------- REPLACE THE UNEQUIPPED LEFT HAND OBJECT --------------------------------------------------------------------------------------
					If(HadSomethingEquippedWeapon)
						PlayerRef.EquipItemEx(EquippedWeaponLeft,2,false,true)
						HadSomethingEquippedWeapon = 0
					ElseIf(HadSomethingEquippedShield)
						PlayerRef.EquipItem(EquippedShield,false,true)
						HadSomethingEquippedShield = 0
					ElseIf(HadSomethingEquippedSpell)
						PlayerRef.EquipSpell(EquippedSpell, 0)
						HadSomethingEquippedSpell = 0
					EndIf
					;-------------------------------------------------------------------------------------------------------------------------------------------------------------

				EquippedWeaponRight.SetEquipType(OneHandedSlot)
				Utility.Wait(0.1+ExtraWaitA)
				PlayerRef.EquipItem(EquippedWeaponRight,false,true)
				utility.wait(1+ExtraWaitA)
	
				EquippedWeaponRight.SetBaseDamage((WeaponDamage.GetValue()) as int)
				EquippedWeaponRight.SetSpeed(WeaponSpeed.GetValue())
				;-----------------------------------------------------------------------------------------------------------------------------------------------------------------
				
				GripHasBeenChanged.SetValue(0)
		;=========================================================

		;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;==========================MACE===========================
		;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++

		;======= IF RIGHT HAND IS WAR AXE + ONE-HANDED ======================
		ElseIf((WeaponEquipTypeRight == (OneHandedSlot||EitherHandedSlot))&&(WeaponTypeRight == MaceType)&&(GripHasBeenChanged.GetValue() == 0))
				debug.trace("[Unlocked Grip] Mace is changing to two-handed mode")

				;---------- REMOVE ANYTHING FROM THE PLAYERS LEFT HAND ---------------------------------------------------------------------------------------
				If(EquippedWeaponLeft)	
					PlayerRef.UnequipItem(EquippedWeaponLeft,false,true)
					HadSomethingEquippedWeapon = 1
				ElseIf(PlayerRef.GetEquippedShield())
					EquippedShield = PlayerRef.GetEquippedShield()
					PlayerRef.UnequipItem(PlayerRef.GetEquippedShield(),false,true)	
					HadSomethingEquippedShield = 1
				ElseIf(PlayerRef.GetEquippedSpell(0))
					EquippedSpell = PlayerRef.GetEquippedSpell(0)
					PlayerRef.UnequipSpell(PlayerRef.GetEquippedSpell(0),0)
					HadSomethingEquippedSpell = 1
				EndIf
				;------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
				;---------- SWITCH THE WEAPON TO TWO-HANDED MODE ---------------------------------------------------------------------------------------------
				PlayerRef.UnequipItem(EquippedWeaponRight,false,true)
				If(SkillsMatch.GetValue())
					EquippedWeaponRight.SetSkill("TwoHanded")
				EndIf
				EquippedWeaponRight.SetEquipType(TwoHandedSlot)
				EquippedWeaponRight.SetWeaponType(GreatswordType)
				utility.wait(0.1+ExtraWaitA)
				PlayerRef.EquipItem(EquippedWeaponRight,false,true)
				Utility.Wait(0.1+ExtraWaitA)
				EquippedWeaponRight.SetWeaponType(MaceType)
				PlayerRef.DrawWeapon()
				utility.wait(1.5)
				EquippedWeaponRight.SetWeaponType(GreatswordType)
	
				EquippedWeaponRight.SetBaseDamage((WeaponDamage.GetValue()*(1.0+DamageChange.GetValue())) as int)
				EquippedWeaponRight.SetSpeed(WeaponSpeed.GetValue()*(1.0+SpeedChange.GetValue()))
				;------------------------------------------------------------------------------------------------------------------------------------------------------------------
				
				GripHasBeenChanged.SetValue(1)
				WasMace = 1
				WasDagger = 0
				WasWarAxe = 0
		;==========================================================

		;======= IF RIGHT HAND IS MACE + TWO HANDED =========================
		ElseIf((WeaponEquipTypeRight == TwoHandedSlot)&&(WeaponTypeRight == GreatswordType)&&(GripHasBeenChanged.GetValue() == 1))
				debug.trace("[Unlocked Grip] Mace is changing to one-handed mode")
				
				;---------- SWITCH THE WEAPON TO ONE-HANDED MODE -----------------------------------------------------------------------------------------------
				PlayerRef.UnequipItem(EquippedWeaponRight,false,true)
				If(SkillsMatch.GetValue())
					EquippedWeaponRight.SetSkill("OneHanded")
				EndIf
				EquippedWeaponRight.SetWeaponType(MaceType)

					;---------- REPLACE THE UNEQUIPPED LEFT HAND OBJECT -----------------------------------------------------------------------------------------
					If(HadSomethingEquippedWeapon)
						PlayerRef.EquipItemEx(EquippedWeaponLeft,2,false,true)
						HadSomethingEquippedWeapon = 0
					ElseIf(HadSomethingEquippedShield)
						PlayerRef.EquipItem(EquippedShield,false,true)
						HadSomethingEquippedShield = 0
					ElseIf(HadSomethingEquippedSpell)
						PlayerRef.EquipSpell(EquippedSpell, 0)
						HadSomethingEquippedSpell = 0
					EndIf
					;---------------------------------------------------------------------------------------------------------------------------------------------------------------

				EquippedWeaponRight.SetEquipType(OneHandedSlot)
				Utility.Wait(0.1+ExtraWaitA)
				PlayerRef.EquipItem(EquippedWeaponRight,false,true)
				utility.wait(1+ExtraWaitA)
	
				EquippedWeaponRight.SetBaseDamage((WeaponDamage.GetValue()) as int)
				EquippedWeaponRight.SetSpeed(WeaponSpeed.GetValue())
				;---------------------------------------------------------------------------------------------------------------------------------------------------------------------
				
				GripHasBeenChanged.SetValue(0)
		;=======================================================

		;+++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;======================GREATSWORD========================
		;+++++++++++++++++++++++++++++++++++++++++++++++++++++++

		;======= IF RIGHT HAND IS GREATSWORD + TWO-HANDED =================
		ElseIf((WeaponEquipTypeRight == TwoHandedSlot)&&(WeaponTypeRight == GreatswordType)&&(GripHasBeenChanged.GetValue() == 0))
				debug.trace("[Unlocked Grip] Greatsword is changing to one-handed mode")

				;---------- SWITCH THE WEAPON TO ONE-HANDED MODE ----------------------------------------------------
				PlayerRef.UnequipItem(EquippedWeaponRight,false,true)			;unequip the right hand weapon
				If(SkillsMatch.GetValue())
					EquippedWeaponRight.SetSkill("OneHanded")
				EndIf
				EquippedWeaponRight.SetEquipType(OneHandedSlot)				;changes the equip type in the menu into R

					;---------- REPLACE THE UNEQUIPPED LEFT HAND OBJECT ----------------------------------------------
					If(HadSomethingEquippedWeapon)
						PlayerRef.EquipItemEx(EquippedWeaponLeft,2,false,true)			;re-equip the unequipped left hand weapon
						HadSomethingEquippedWeapon = 0
					ElseIf(HadSomethingEquippedShield)
						PlayerRef.EquipItem(EquippedShield,false,true)						;re-equip the unequipped shield
						HadSomethingEquippedShield = 0
					ElseIf(HadSomethingEquippedSpell)
						PlayerRef.EquipSpell(EquippedSpell, 0)								;re-equip the unequipped left hand spell
						HadSomethingEquippedSpell = 0
					EndIf
					;-------------------------------------------------------------------------------------------------------------------
				EquippedWeaponRight.SetWeaponType(SwordType)					;changes the weapon type to two-handed, affects animations
				Utility.Wait(0.1+ExtraWaitA)
				PlayerRef.EquipItem(EquippedWeaponRight,false,true)				;re-equip the right hand weapon
				Utility.Wait(0.1+ExtraWaitA)
				EquippedWeaponRight.SetWeaponType(GreatswordType)			;changes the weapon type to two-handed, affects animations
				PlayerRef.DrawWeapon()											;draw the right hand weapon, required
				utility.wait(1.4)														;necessary wait time for the draw animation
				EquippedWeaponRight.SetWeaponType(SwordType)					;fix the invisible left hand weapon bug, allows blocking

				EquippedWeaponRight.SetBaseDamage((WeaponDamage.GetValue()*(1.0-DamageChange.GetValue())) as int)
				EquippedWeaponRight.SetSpeed(WeaponSpeed.GetValue()*(1.0-SpeedChange.GetValue()))
				;------------------------------------------------------------------------------------------------------------------------
				
				GripHasBeenChanged.SetValue(1)
				WasMace = 0
				WasDagger = 0
				WasWarAxe = 0
		;=========================================================

		;======= IF RIGHT HAND IS GREATSWORD + ONE-HANDED ===================
		ElseIf((WeaponEquipTypeRight == OneHandedSlot)&&(WeaponTypeRight == SwordType)&&(GripHasBeenChanged.GetValue() == 1))
				debug.trace("[Unlocked Grip] Greatsword is changing to two-handed mode")

				;---------- REMOVE ANYTHING FROM THE PLAYERS LEFT HAND ----------------------------------------------
				If(EquippedWeaponLeft)													;Check for anything in the left hand and unequip it if true
					PlayerRef.UnequipItem(EquippedWeaponLeft,false,true)				;unequip the left hand weapon
					HadSomethingEquippedWeapon = 1
				ElseIf(PlayerRef.GetEquippedShield())
					EquippedShield = PlayerRef.GetEquippedShield()						;record the shields' id
					PlayerRef.UnequipItem(PlayerRef.GetEquippedShield(),false,true)		;unequips any shield
					HadSomethingEquippedShield = 1
				ElseIf(PlayerRef.GetEquippedSpell(0))
					EquippedSpell = PlayerRef.GetEquippedSpell(0)						;record the spells' id
					PlayerRef.UnequipSpell(PlayerRef.GetEquippedSpell(0),0)				;unequips the left hand spell
					HadSomethingEquippedSpell = 1
				EndIf
				;------------------------------------------------------------------------------------------------------------------------
	
				;---------- SWITCH THE WEAPON TO TWO-HANDED MODE ---------------------------------------------------
				PlayerRef.UnequipItem(EquippedWeaponRight,false,true)			;unequip the right hand weapon
				If(SkillsMatch.GetValue())
					EquippedWeaponRight.SetSkill("TwoHanded")
				EndIf
				EquippedWeaponRight.SetWeaponType(GreatswordType)			;change the weapon type to two-handed, affects animations
				EquippedWeaponRight.SetEquipType(TwoHandedSlot)				;change the equip type in the menu into LR
				EquippedWeaponRight.SetBaseDamage((WeaponDamage.GetValue()) as int)
				EquippedWeaponRight.SetSpeed(WeaponSpeed.GetValue())
				Utility.Wait(0.1+ExtraWaitA)
				PlayerRef.EquipItem(EquippedWeaponRight,false,true)				;re-equip the right hand weapon
				utility.wait(1+ExtraWaitA)	
				;------------------------------------------------------------------------------------------------------------------------
				
				GripHasBeenChanged.SetValue(0)
		;========================================================

		;++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;=================BATTLEAXE AND WARHAMMER====================
		;++++++++++++++++++++++++++++++++++++++++++++++++++++++++

		;======= IF RIGHT HAND IS BATTLEAXE + TWO-HANDED ====================
		ElseIf((WeaponEquipTypeRight == TwoHandedSlot)&&(WeaponTypeRight == BattleaxeWarhammerType)&&(GripHasBeenChanged.GetValue() == 0))
				debug.trace("[Unlocked Grip] Weapon is changing to one-handed mode")

				;---------- SWITCH THE WEAPON TO ONE-HANDED MODE -----------------------------------------------------
				PlayerRef.UnequipItem(EquippedWeaponRight,false,true)
				If(SkillsMatch.GetValue())
					EquippedWeaponRight.SetSkill("OneHanded")
				EndIf
				EquippedWeaponRight.SetEquipType(OneHandedSlot)

					;---------- REPLACE THE UNEQUIPPED LEFT HAND OBJECT ----------------------------------------------
					If(HadSomethingEquippedWeapon)
						PlayerRef.EquipItemEx(EquippedWeaponLeft,2,false,true)
						HadSomethingEquippedWeapon = 0
					ElseIf(HadSomethingEquippedShield)
						PlayerRef.EquipItem(EquippedShield,false,true)
						HadSomethingEquippedShield = 0
					ElseIf(HadSomethingEquippedSpell)
						PlayerRef.EquipSpell(EquippedSpell, 0)
						HadSomethingEquippedSpell = 0
					EndIf
					;-------------------------------------------------------------------------------------------------------------------
				EquippedWeaponRight.SetWeaponType(WarAxeType)
				Utility.Wait(0.1+ExtraWaitA)
				PlayerRef.EquipItem(EquippedWeaponRight,false,true)
				Utility.Wait(0.1+ExtraWaitA)
				EquippedWeaponRight.SetWeaponType(BattleaxeWarhammerType)
				PlayerRef.DrawWeapon()
				utility.wait(1.4)
				EquippedWeaponRight.SetWeaponType(WarAxeType)

				EquippedWeaponRight.SetBaseDamage((WeaponDamage.GetValue()*(1.0-DamageChange.GetValue())) as int)
				EquippedWeaponRight.SetSpeed(WeaponSpeed.GetValue()*(1.0-SpeedChange.GetValue()))
				;------------------------------------------------------------------------------------------------------------------------
				
				GripHasBeenChanged.SetValue(1)
				WasMace = 0
				WasDagger = 0
				WasWarAxe = 0
		;===========================================================

		;======= IF RIGHT HAND IS BATTLEAXE + ONE-HANDED =======================
		ElseIf((WeaponEquipTypeRight == OneHandedSlot)&&(WeaponTypeRight == WarAxeType)&&(GripHasBeenChanged.GetValue() == 1))
				debug.trace("[Unlocked Grip] Weapon is changing to two-handed mode")

				;---------- REMOVE ANYTHING FROM THE PLAYERS LEFT HAND ---------------------------------------------
				If(EquippedWeaponLeft)	
					PlayerRef.UnequipItem(EquippedWeaponLeft,false,true)
					HadSomethingEquippedWeapon = 1
				ElseIf(PlayerRef.GetEquippedShield())
					EquippedShield = PlayerRef.GetEquippedShield()
					PlayerRef.UnequipItem(PlayerRef.GetEquippedShield(),false,true)	
					HadSomethingEquippedShield = 1
				ElseIf(PlayerRef.GetEquippedSpell(0))
					EquippedSpell = PlayerRef.GetEquippedSpell(0)
					PlayerRef.UnequipSpell(PlayerRef.GetEquippedSpell(0),0)
					HadSomethingEquippedSpell = 1
				EndIf
				;------------------------------------------------------------------------------------------------------------------------
	
				;---------- SWITCH THE WEAPON TO TWO-HANDED MODE ---------------------------------------------------
				PlayerRef.UnequipItem(EquippedWeaponRight,false,true)
				If(SkillsMatch.GetValue())
					EquippedWeaponRight.SetSkill("TwoHanded")
				EndIf
				EquippedWeaponRight.SetWeaponType(BattleaxeWarhammerType)
				EquippedWeaponRight.SetEquipType(TwoHandedSlot)
				EquippedWeaponRight.SetBaseDamage((WeaponDamage.GetValue()) as int)
				EquippedWeaponRight.SetSpeed(WeaponSpeed.GetValue())
				Utility.Wait(0.1+ExtraWaitA)
				PlayerRef.EquipItem(EquippedWeaponRight,false,true)
				utility.wait(1+ExtraWaitA)	
				;------------------------------------------------------------------------------------------------------------------------
				
				GripHasBeenChanged.SetValue(0)
		EndIf
		;============================================================

		debug.trace("[Unlocked Grip] Grip changing is finished")
	EndIf
	DSerScriptRunning.SetValue(0)
EndEvent

Event OnKeyUp(int KeyCode, float HoldTime)
	If(KeyCode == GlobalHotkey.GetValue())
		Modifier = 0
	EndIf
EndEvent