Scriptname DSerGripMonitorScript extends activemagiceffect

GlobalVariable Property DSerScriptRunning  auto
GlobalVariable Property GripHasBeenChanged auto
GlobalVariable Property BattleaxeBackSheath auto
GlobalVariable Property GreatswordBackSheath auto
GlobalVariable Property ResetRequest auto
GlobalVariable Property ExtraWait auto
GlobalVariable Property AutoGripGlobal auto
GlobalVariable Property WeaponDamage auto
GlobalVariable Property WeaponSpeed auto
GlobalVariable Property SkillsMatch auto
DSerBastardSword property BastardSwordScript auto
actor PlayerRef

int SwordType = 1
int DaggerType = 2
int WarAxeType = 3
int MaceType = 4
int GreatswordType = 5
int BattleAxeWarhammerType = 6
int WeaponType
int OriginalWeaponType
int ResetingState = 0
int ReadyWeaponKey
int ReadyWeaponKey2

float ExtraWaitA

equipslot OneHandedSlot
equipslot TwoHandedSlot

weapon YourWeapon
weapon YourOldWeapon

Event OnEffectStart(Actor akTarget, Actor akCaster)
	If(Game.GetPlayer().GetEquippedWeapon())
		Game.GetPlayer().UnequipItemEx(Game.GetPlayer().GetEquippedWeapon() as form, 1, false)			;remove any weapon from the right hand
	EndIf
	If(Game.GetPlayer().GetEquippedWeapon(true))
		Game.GetPlayer().UnequipItemEx(Game.GetPlayer().GetEquippedWeapon(true) as form, 2, false)		;remove any weapon from the left hand
	EndIf
EndEvent


Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	If(GripHasBeenChanged.GetValueInt() == 0)
		If(ResetingState == 1)
			utility.waitmenumode(0.25)
		EndIf
		If(akBaseObject as Weapon)&&(DSerScriptRunning.GetValueInt() == 0)
			utility.waitmenumode(0.1)
			DSerScriptRunning.SetValue(1)
			PlayerRef = Game.GetPlayer()
			If((akBaseObject as Weapon) == PlayerRef.GetEquippedWeapon())
				YourWeapon = akBaseObject as Weapon
				If(YourWeapon.GetWeaponType() > 0)&&(YourWeapon.GetWeaponType() < 7)
					OriginalWeaponType = YourWeapon.GetWeaponType()					;set the original weapon type, i'll be using this in the unequip event
					debug.trace("[Unlocked Grip] OriginalWeaponType is now " + OriginalWeaponType)
					WeaponDamage.SetValue(YourWeapon.GetBaseDamage())
					WeaponSpeed.SetValue(YourWeapon.GetSpeed())
					If(WeaponDamage.GetValue() == 0)||(WeaponSpeed.GetValue() == 0)
						debug.messagebox("[Unlocked Grip] Weapon Damage or Speed is zero! Re-equip your weapon or use the reset functions in the MCM.")
					EndIf
				EndIf
				
				;===========BATTLEAXE ON BACK================
				If(BattleaxeBackSheath.GetValueInt() == 1)&&(PlayerRef.GetEquippedWeapon().GetWeaponType() == 6)
					ReadyWeaponKey = Input.GetMappedKey("Ready Weapon")
					RegisterForKey(ReadyWeaponKey)
					ReadyWeaponKey2 = Input.GetMappedKey("Right Attack/Block")
					RegisterForKey(ReadyWeaponKey2)
				EndIf

				;===========GREATSWORD ON BACK==============
				If(GreatswordBackSheath.GetValueInt() == 1)&&(PlayerRef.GetEquippedWeapon().GetWeaponType() == 5)
					ReadyWeaponKey = Input.GetMappedKey("Ready Weapon")
					RegisterForKey(ReadyWeaponKey)
					ReadyWeaponKey2 = Input.GetMappedKey("Right Attack/Block")
					RegisterForKey(ReadyWeaponKey2)
				EndIf

				;==========NEITHER ARE ENABLED================
				If((BattleaxeBackSheath.GetValueInt() == 0)&&(GreatswordBackSheath.GetValueInt() == 0)&&(ReadyWeaponKey != 0))
					UnregisterForKey(ReadyWeaponKey)
				EndIf

			EndIf
			YourOldWeapon = YourWeapon
			DSerScriptRunning.SetValue(0)
		EndIf
	EndIf
	If(AutoGripGlobal.GetValue() == 1)&&(GripHasBeenChanged.GetValue() == 1)&&(ResetingState == 1)
			utility.waitmenumode(0.2)
		If(akBaseObject as Spell)
			If(YourOldWeapon.GetEquipType() == OneHandedSlot)
				((Self as ActiveMagicEffect) as DSerBastardSword).DontRun()
				utility.waitmenumode(0.05)
				PlayerRef.EquipItem(YourOldWeapon, false, true)
				utility.waitmenumode(0.05)
				((Self as ActiveMagicEffect) as DSerBastardSword).Run()
			EndIf
		ElseIf(akBaseObject as Armor)
			If(akBaseObject as Armor == PlayerRef.GetEquippedShield())
				If(YourOldWeapon.GetEquipType() == OneHandedSlot)
					((Self as ActiveMagicEffect) as DSerBastardSword).DontRun()
					utility.waitmenumode(0.05)
					PlayerRef.EquipItem(YourOldWeapon, false, true)
					utility.waitmenumode(0.05)
					((Self as ActiveMagicEffect) as DSerBastardSword).Run()
				EndIf
			EndIf
		ElseIf(akBaseObject as Weapon)
			If(akBaseObject as Weapon == PlayerRef.GetEquippedWeapon(true))
				If(YourOldWeapon.GetEquipType() == OneHandedSlot)
					((Self as ActiveMagicEffect) as DSerBastardSword).DontRun()
					utility.waitmenumode(0.05)
					PlayerRef.EquipItem(YourOldWeapon, false, true)
					utility.waitmenumode(0.05)
					((Self as ActiveMagicEffect) as DSerBastardSword).Run()
				EndIf
			EndIf
		EndIf
	EndIf
EndEvent


Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	ResetingState = 1
	If(ResetRequest.GetValue() == 1)
		ResetRequest.SetValue(0)
		GripHasBeenChanged.SetValue(0)
		ResetingState = 0
		return
	ElseIf (akBaseObject as Weapon)&&(DSerScriptRunning.GetValueInt() == 0)
		WeaponType = (akBaseObject as Weapon).GetWeaponType()

		If(WeaponType == OriginalWeaponType)
			ResetingState = 0
			return
		EndIf

		DSerScriptRunning.SetValue(1)
		PlayerRef = Game.GetPlayer()

		OneHandedSlot = Game.GetForm(0x00013f42) As EquipSlot					;returns the weapon slot for a one handed weapon
		TwoHandedSlot = Game.GetForm(0x00013F45) As EquipSlot					;returns the weapon slot for a two handed weapon

		If(WeaponType == 1)&&(OriginalWeaponType == 5)
				debug.trace("[Unlocked Grip] A modified greatsword has been unequipped")

				;---------- SWITCH THE WEAPON TO TWO-HANDED MODE -----------------------------------------------------------------------------------------------------------------------------------------
				YourOldWeapon.SetWeaponType(GreatswordType)						;change the weapon type to two-handed, affects animations
				YourOldWeapon.SetEquipType(TwoHandedSlot)							;change the equip type in the menu into LR
				YourOldWeapon.SetBaseDamage((WeaponDamage.GetValue()) as int)		;reset the damage
				YourOldWeapon.SetSpeed(WeaponSpeed.GetValue())					;reset the speed
				If(SkillsMatch.GetValue())
					YourOldWeapon.SetSkill("TwoHanded")								;reset the skill
				EndIf

				PlayerRef.EquipItem(YourOldWeapon, false, true)
				PlayerRef.UnequipItem(YourOldWeapon, false, true)
				;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
				utility.waitmenumode(0.1)
				GripHasBeenChanged.SetValue(0)

		ElseIf(WeaponType == 3)&&(OriginalWeaponType == 6)
				debug.trace("[Unlocked Grip] A modified battleaxe has been unequipped")

				;---------- SWITCH THE WEAPON TO TWO-HANDED MODE -----------------------------------------------------------------------------------------------------------------------------------------
				YourOldWeapon.SetWeaponType(BattleaxeWarhammerType)				;change the weapon type to two-handed, affects animations
				YourOldWeapon.SetEquipType(TwoHandedSlot)							;change the equip type in the menu into LR
				YourOldWeapon.SetBaseDamage((WeaponDamage.GetValue()) as int)		;reset the damage
				YourOldWeapon.SetSpeed(WeaponSpeed.GetValue())					;reset the speed
				If(SkillsMatch.GetValue())
					YourOldWeapon.SetSkill("TwoHanded")								;reset the skill
				EndIf

				PlayerRef.EquipItem(YourOldWeapon, false, true)
				PlayerRef.UnequipItem(YourOldWeapon, false, true)
				;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
				utility.waitmenumode(0.1)
				GripHasBeenChanged.SetValue(0)
	
		ElseIf(WeaponType == 5)&&(OriginalWeaponType == (1||2||3||4))
			If(OriginalWeaponType == 1)
				debug.trace("[Unlocked Grip] A modified sword has been unequipped")

				;---------- SWITCH THE WEAPON TO ONE-HANDED MODE -----------------------------------------------------------------------------------------------------------------------------------------
				YourOldWeapon.SetWeaponType(SwordType)							;change the weapon type to one-handed, affects animations
				YourOldWeapon.SetEquipType(OneHandedSlot)							;change the equip type in the menu into R
				YourOldWeapon.SetBaseDamage((WeaponDamage.GetValue()) as int)		;reset the damage
				YourOldWeapon.SetSpeed(WeaponSpeed.GetValue())					;reset the speed
				If(SkillsMatch.GetValue())
					YourOldWeapon.SetSkill("OneHanded")								;reset the skill
				EndIf

				PlayerRef.EquipItem(YourOldWeapon, false, true)
				PlayerRef.UnequipItem(YourOldWeapon, false, true)
				;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
				utility.waitmenumode(0.1)
				GripHasBeenChanged.SetValue(0)

			ElseIf(OriginalWeaponType ==2)
				debug.trace("[Unlocked Grip] A modified dagger has been unequipped")

				;---------- SWITCH THE WEAPON TO ONE-HANDED MODE -----------------------------------------------------------------------------------------------------------------------------------------
				YourOldWeapon.SetWeaponType(DaggerType)							;change the weapon type to one-handed, affects animations
				YourOldWeapon.SetEquipType(OneHandedSlot)							;change the equip type in the menu into R
				YourOldWeapon.SetBaseDamage((WeaponDamage.GetValue()) as int)		;reset the damage
				YourOldWeapon.SetSpeed(WeaponSpeed.GetValue())					;reset the speed
				If(SkillsMatch.GetValue())
					YourOldWeapon.SetSkill("OneHanded")								;reset the skill
				EndIf

				PlayerRef.EquipItem(YourOldWeapon, false, true)
				PlayerRef.UnequipItem(YourOldWeapon, false, true)
				;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
				utility.waitmenumode(0.1)
				GripHasBeenChanged.SetValue(0)

			ElseIf(OriginalWeaponType ==3)
				debug.trace("[Unlocked Grip] A modified war axe has been unequipped")

				;---------- SWITCH THE WEAPON TO ONE-HANDED MODE -----------------------------------------------------------------------------------------------------------------------------------------
				YourOldWeapon.SetWeaponType(WarAxeType)							;change the weapon type to one-handed, affects animations
				YourOldWeapon.SetEquipType(OneHandedSlot)							;change the equip type in the menu into R
				YourOldWeapon.SetBaseDamage((WeaponDamage.GetValue()) as int)		;reset the damage
				YourOldWeapon.SetSpeed(WeaponSpeed.GetValue())					;reset the speed
				If(SkillsMatch.GetValue())
					YourOldWeapon.SetSkill("OneHanded")								;reset the skill
				EndIf

				PlayerRef.EquipItem(YourOldWeapon, false, true)
				PlayerRef.UnequipItem(YourOldWeapon, false, true)
				;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
				utility.waitmenumode(0.1)
				GripHasBeenChanged.SetValue(0)

			ElseIf(OriginalWeaponType ==4)
				debug.trace("[Unlocked Grip] A modified mace has been unequipped")

				;---------- SWITCH THE WEAPON TO ONE-HANDED MODE -----------------------------------------------------------------------------------------------------------------------------------------
				YourOldWeapon.SetWeaponType(MaceType)							;change the weapon type to one-handed, affects animations
				YourOldWeapon.SetEquipType(OneHandedSlot)							;change the equip type in the menu into R
				YourOldWeapon.SetBaseDamage((WeaponDamage.GetValue()) as int)		;reset the damage
				YourOldWeapon.SetSpeed(WeaponSpeed.GetValue())					;reset the speed
				If(SkillsMatch.GetValue())
					YourOldWeapon.SetSkill("OneHanded")								;reset the skill
				EndIf

				PlayerRef.EquipItem(YourOldWeapon, false, true)
				PlayerRef.UnequipItem(YourOldWeapon, false, true)
				;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
				utility.waitmenumode(0.1)
				GripHasBeenChanged.SetValue(0)

			EndIf
		EndIf
		DSerScriptRunning.SetValue(0)
	EndIf
	ResetingState = 0
EndEvent


Event OnKeyDown(int KeyCode)					;This event handles the back sheath options
	ExtraWaitA = ExtraWait.GetValue()
	If(Utility.IsInMenuMode() == true)
		return
	EndIf
	If(DSerScriptRunning.GetValueInt() == 0)
		DSerScriptRunning.SetValueInt(1)
		If(OriginalWeaponType == 6)&&(YourWeapon.GetWeaponType() == 3)&&(BattleaxeBackSheath.GetValueInt() == 1)	;Battleaxes and warhammers
			If(KeyCode == ReadyWeaponKey)
				If(PlayerRef.IsWeaponDrawn())									;Player started to sheath their battleaxe/warhammer
					YourWeapon.SetWeaponType(BattleaxeWarhammerType)	;change the weapon type to two-handed, affects animations
					utility.waitmenumode(1)
					YourWeapon.SetWeaponType(WarAxeType)					;change the weapon type to one-handed, affects animations
				ElseIf(!(PlayerRef.IsWeaponDrawn()))							;Player started to draw their battleaxe/warhammer

					;---------- SWITCH THE WEAPON TO ONE-HANDED MODE ---------------------------------------------------------------------------------------------
					Utility.Wait(0.05+(ExtraWaitA*0.2))
					PlayerRef.UnequipItem(YourWeapon,false,true)
					YourWeapon.SetEquipType(OneHandedSlot)
					PlayerRef.EquipItem(YourWeapon,false,true)
					Utility.Wait(0.05+(ExtraWaitA*0.2))
					YourWeapon.SetWeaponType(BattleaxeWarhammerType)
					utility.wait(1.0+ExtraWaitA)
					YourWeapon.SetWeaponType(WarAxeType)
					;-----------------------------------------------------------------------------------------------------------------------------------------------------------------
				EndIf
			ElseIf(KeyCode == ReadyWeaponKey2)
				If(!(PlayerRef.IsWeaponDrawn()))								;Player started to draw their battleaxe/warhammer
					;---------- SWITCH THE WEAPON TO ONE-HANDED MODE ---------------------------------------------------------------------------------------------
					Utility.Wait(0.05+ExtraWaitA)
					PlayerRef.UnequipItem(YourWeapon,false,true)
					YourWeapon.SetEquipType(OneHandedSlot)
					PlayerRef.EquipItem(YourWeapon,false,true)
					Utility.Wait(0.05+(ExtraWaitA*0.2))
					YourWeapon.SetWeaponType(BattleaxeWarhammerType)
					utility.wait(1.0+ExtraWaitA)
					YourWeapon.SetWeaponType(WarAxeType)
					;-----------------------------------------------------------------------------------------------------------------------------------------------------------------
				EndIf
			EndIf
		ElseIf(OriginalWeaponType == 5)&&(YourWeapon.GetWeaponType() == 1)&&(GreatswordBackSheath.GetValueInt() == 1)	;Greatsword
			If(KeyCode == ReadyWeaponKey)
				If(PlayerRef.IsWeaponDrawn())									;Player started to sheath their greatsword
					YourWeapon.SetWeaponType(GreatswordType)				;change the weapon type to two-handed, affects animations
					utility.waitmenumode(1)
					YourWeapon.SetWeaponType(SwordType)					;change the weapon type to one-handed, affects animations
				ElseIf(!(PlayerRef.IsWeaponDrawn()))							;Player started to draw their greatsword
					;---------- SWITCH THE WEAPON TO ONE-HANDED MODE ---------------------------------------------------------------------------------------------
					Utility.Wait(0.05+(ExtraWaitA*0.2))
					PlayerRef.UnequipItem(YourWeapon,false,true)
					YourWeapon.SetEquipType(OneHandedSlot)
					PlayerRef.EquipItem(YourWeapon,false,true)
					Utility.Wait(0.05+(ExtraWaitA*0.2))
					YourWeapon.SetWeaponType(GreatswordType)
					utility.wait(1.0+ExtraWaitA)
					YourWeapon.SetWeaponType(SwordType)
					;-----------------------------------------------------------------------------------------------------------------------------------------------------------------
				EndIf
			ElseIf(KeyCode == ReadyWeaponKey2)
				If(!(PlayerRef.IsWeaponDrawn()))								;Player started to draw their greatsword
					;---------- SWITCH THE WEAPON TO ONE-HANDED MODE ---------------------------------------------------------------------------------------------
					Utility.Wait(0.05+(ExtraWaitA*0.2))
					PlayerRef.UnequipItem(YourWeapon,false,true)
					YourWeapon.SetEquipType(OneHandedSlot)
					PlayerRef.EquipItem(YourWeapon,false,true)
					Utility.Wait(0.05+(ExtraWaitA*0.2))
					YourWeapon.SetWeaponType(GreatswordType)
					utility.wait(1.0+ExtraWaitA)
					YourWeapon.SetWeaponType(SwordType)
					;-----------------------------------------------------------------------------------------------------------------------------------------------------------------
				EndIf
			EndIf
		EndIf
		DSerScriptRunning.SetValueInt(0)
	EndIf
EndEvent

Event OnPlayerLoadGame()
	If(GripHasBeenChanged.GetValueInt() == 1)
		debug.trace("[Unlocked Grip] Weapon was left in non-default grip when saving.")
			ResetRequest.SetValue(1)
			utility.wait(3)
			YourOldWeapon = PlayerRef.GetEquippedWeapon()
			Game.GetPlayer().UnequipItem(YourOldWeapon as form, false, true)
			debug.trace("[Unlocked Grip] Weapon is changing back to normal. Original Weapon type: " + OriginalWeaponType)
			Game.GetPlayer().UnequipItem(PlayerRef.GetEquippedWeapon(),false,true)
			utility.wait(0.5)
		If(OriginalWeaponType == 1)
			YourWeapon.SetWeaponType(1)
			YourWeapon.SetEquipType(Game.GetForm(0x00013f42) As EquipSlot)
			YourOldWeapon.SetBaseDamage((WeaponDamage.GetValue()) as int)
			YourOldWeapon.SetSpeed(WeaponSpeed.GetValue())
			utility.wait(0.5)
			Game.getplayer().EquipItem(YourOldWeapon as form, false, true)
		ElseIf(OriginalWeaponType == 2)
			YourWeapon.SetWeaponType(2)
			YourWeapon.SetEquipType(Game.GetForm(0x00013f42) As EquipSlot)
			YourOldWeapon.SetBaseDamage((WeaponDamage.GetValue()) as int)
			YourOldWeapon.SetSpeed(WeaponSpeed.GetValue())
			utility.wait(0.5)
			Game.getplayer().EquipItem(YourOldWeapon as form, false, true)
		ElseIf(OriginalWeaponType == 3)
			YourWeapon.SetWeaponType(3)
			YourWeapon.SetEquipType(Game.GetForm(0x00013f42) As EquipSlot)
			YourOldWeapon.SetBaseDamage((WeaponDamage.GetValue()) as int)
			YourOldWeapon.SetSpeed(WeaponSpeed.GetValue())
			utility.wait(0.5)
			Game.getplayer().EquipItem(YourOldWeapon as form, false, true)
		ElseIf(OriginalWeaponType == 4)
			YourWeapon.SetWeaponType(4)
			YourWeapon.SetEquipType(Game.GetForm(0x00013f42) As EquipSlot)
			YourOldWeapon.SetBaseDamage((WeaponDamage.GetValue()) as int)
			YourOldWeapon.SetSpeed(WeaponSpeed.GetValue())
			utility.wait(0.5)
			Game.getplayer().EquipItem(YourOldWeapon as form, false, true)
		ElseIf(OriginalWeaponType == 5)
			YourWeapon.SetWeaponType(5)
			YourWeapon.SetEquipType(Game.GetForm(0x00013f45) As EquipSlot)
			YourOldWeapon.SetBaseDamage((WeaponDamage.GetValue()) as int)
			YourOldWeapon.SetSpeed(WeaponSpeed.GetValue())
			utility.wait(0.5)
			Game.getplayer().EquipItem(YourOldWeapon as form, false, true)
		ElseIf(OriginalWeaponType == 6)
			YourWeapon.SetWeaponType(6)
			YourWeapon.SetEquipType(Game.GetForm(0x00013f45) As EquipSlot)
			YourOldWeapon.SetBaseDamage((WeaponDamage.GetValue()) as int)
			YourOldWeapon.SetSpeed(WeaponSpeed.GetValue())
			utility.wait(0.5)
			Game.getplayer().EquipItem(YourOldWeapon as form, false, true)
		EndIf
	EndIf
endEvent